diff -urN qmail-1.03-vanilla/qmail-popup.c qmail-1.03-md24/qmail-popup.c
--- qmail-1.03-vanilla/qmail-popup.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/qmail-popup.c	2007-08-13 21:27:10.000000000 +0200
@@ -1,4 +1,20 @@
+/*
+ * mtime: TR 2007-07-28
+ *
+ * control/log/pop3_fd     -> the logging file desciptor
+ * control/log/pop3_in     -> enable/disable logging of incoming cmd's from client
+ * control/log/pop3_out    -> enable/disable logging of outgoing server resonses
+ *
+ * + sasl authentication (rfc1734)
+ *   - methods: plain, login, cram-md5, cram-sha1, cram-ripemd, digest-md5
+ */
+#include <sys/types.h>
+#include <sys/stat.h>
+#include <unistd.h>
+#include "auto_qmail.h"
 #include "commands.h"
+#include "control.h"
+#include "scan.h"
 #include "fd.h"
 #include "sig.h"
 #include "stralloc.h"
@@ -13,93 +29,127 @@
 #include "readwrite.h"
 #include "timeoutread.h"
 #include "timeoutwrite.h"
+#include "stralloc.h"
+#include "case.h"
+#include "env.h"
+#include "out_log.h"
+#include "qmail-sasl.h"
+#include "ucspitls.h"
+
+char ssinbuf[1024];
+char ssoutbuf[1024];
+char sserrbuf[1024];
+
+substdio ssin = SUBSTDIO_FDBUF(saferead,0,ssinbuf,sizeof ssinbuf);
+substdio ssout = SUBSTDIO_FDBUF(safewrite,1,ssoutbuf,sizeof ssoutbuf);
+substdio sserr = SUBSTDIO_FDBUF(safewrite,-1,sserrbuf,sizeof sserrbuf);
+
+stralloc username = {0};
+char **childargs;
+char *hostname;
+char *name="qmail-popup";
+
+int ctl_log_in=0;
+int ctl_log_out=0;
+int ctl_log_fd=2;
+int ctl_logindelay=0; /* how can we do this ? */
+int ctl_expire=0;
+int ctl_auth_delay=5;
+int ctl_auth_secure=(1|2|4|8|16); /* sasl methods in TLS mode */
+int ctl_auth_insecure=(4|8|16); /* sasl methods in NON-TLS mode */
+int *ctl_auth_current = &ctl_auth_insecure;
+int ctl_maxcmdlen;
+
+int tls_available = 0;
+int tls_started = 0;
+
+char logindelay[FMT_ULONG+22];
+char expire[FMT_ULONG+22];
+
+int seenuser = 0;
+char upbuf[128];
+substdio ssup;
+
+void die() { flush(); _exit(1); }
+
+void err(char *s)
+{
+  doserv();
+  if (s) {
+    out("-ERR "); out(s);
+  } else {
+    out("-ERR");
+  }
+  doeol();
+  flush();
+}
 
-void die() { _exit(1); }
+void ok(char *s)
+{
+  doserv(); out("+OK");
+  if (s) out(s);
+  doeol(); flush();
+}
+
+void err_die(char *s) { err(s);die(); }
+
+/* rfc: [SYS/PERM] [SYS/TEMP] [AUTH] [IN-USE] */
+void die_read()      { doname();Log("client exited\n");_exit(0); }
+void die_usage()     { err_die("[SYS/TEMP] usage: popup hostname checkprogram subprogram"); }
+void die_nomem()     { err_die("[SYS/TEMP] out of memory"); }
+void die_pipe()      { err_die("[SYS/TEMP] unable to open pipe"); }
+void die_write()     { err_die("[SYS/TEMP] unable to write pipe"); }
+void die_fork()      { err_die("[SYS/TEMP] unable to fork"); }
+void die_child()     { err_die("[SYS/TEMP] aack, child crashed"); }
+void die_control()   { err_die("[SYS/TEMP] unable to read controls"); }
+void die_lcmd()      { err_die("[SYS/TEMP] the given command is too long!"); }
+void die_tls()       { err_die("[SYS/TEMP] TLS startup failed"); }
+
+void err_wantauth()  { err("[SYS/PERM] authorization first"); }
+void err_authfail()  { err("[AUTH] authorization failed"); }
+void err_authin()    { err("[AUTH] invalid authorization input"); }
+int  err_noauth()    { err("auth type unimplemented"); return -1; }
+int  err_authabrt()  { err("auth exchange cancelled"); return -1; }
+void err_wantuser()  { err("USER first"); }
+void err_syntax()    { err("syntax error"); }
+void err_unimpl()    { err("unimplemented"); }
 
-int saferead(fd,buf,len) int fd; char *buf; int len;
+int saferead(int fd, char *buf, int len)
 {
   int r;
   r = timeoutread(1200,fd,buf,len);
-  if (r <= 0) die();
+  if (r <= 0) die_read();
   return r;
 }
 
-int safewrite(fd,buf,len) int fd; char *buf; int len;
+int safewrite(int fd, char *buf, int len)
 {
   int r;
   r = timeoutwrite(1200,fd,buf,len);
-  if (r <= 0) die();
+  if (r <= 0) die_write();
   return r;
 }
 
-char ssoutbuf[128];
-substdio ssout = SUBSTDIO_FDBUF(safewrite,1,ssoutbuf,sizeof ssoutbuf);
-
-char ssinbuf[128];
-substdio ssin = SUBSTDIO_FDBUF(saferead,0,ssinbuf,sizeof ssinbuf);
-
-void puts(s) char *s;
-{
-  substdio_puts(&ssout,s);
-}
-void flush()
-{
-  substdio_flush(&ssout);
-}
-void err(s) char *s;
-{
-  puts("-ERR ");
-  puts(s);
-  puts("\r\n");
-  flush();
-}
-
-void die_usage() { err("usage: popup hostname subprogram"); die(); }
-void die_nomem() { err("out of memory"); die(); }
-void die_pipe() { err("unable to open pipe"); die(); }
-void die_write() { err("unable to write pipe"); die(); }
-void die_fork() { err("unable to fork"); die(); }
-void die_childcrashed() { err("aack, child crashed"); }
-void die_badauth() { err("authorization failed"); }
-
-void err_syntax() { err("syntax error"); }
-void err_wantuser() { err("USER first"); }
-void err_authoriz() { err("authorization first"); }
-
-void okay() { puts("+OK \r\n"); flush(); }
-void pop3_quit() { okay(); die(); }
-
-
-char unique[FMT_ULONG + FMT_ULONG + 3];
-char *hostname;
-stralloc username = {0};
-int seenuser = 0;
-char **childargs;
-substdio ssup;
-char upbuf[128];
-
-
 void doanddie(user,userlen,pass)
-char *user;
-unsigned int userlen; /* including 0 byte */
-char *pass;
+  char *user;
+  unsigned int userlen; /* including 0 byte */
+  char *pass;
 {
   int child;
   int wstat;
   int pi[2];
- 
+
   if (fd_copy(2,1) == -1) die_pipe();
   close(3);
   if (pipe(pi) == -1) die_pipe();
   if (pi[0] != 3) die_pipe();
   switch(child = fork()) {
-    case -1:
-      die_fork();
+    case -1: die_fork(); break;
     case 0:
       close(pi[1]);
       sig_pipedefault();
       execvp(*childargs,childargs);
-      _exit(1);
+      _exit(0);
   }
   close(pi[0]);
   substdio_fdbuf(&ssup,write,pi[1],upbuf,sizeof upbuf);
@@ -113,71 +163,275 @@
   close(pi[1]);
   byte_zero(pass,str_len(pass));
   byte_zero(upbuf,sizeof upbuf);
-  if (wait_pid(&wstat,child) == -1) die();
-  if (wait_crashed(wstat)) die_childcrashed();
-  if (wait_exitcode(wstat)) die_badauth();
+  if (wait_pid(&wstat,child) == -1) die_child();
+  if (wait_crashed(wstat)) die_child();
+  if (wait_exitcode(wstat)) { err_authfail(); return; }
   die();
 }
+
+void pop3_okay() { ok(0); }
+void pop3_quit() { ok(0);_exit(0); }
+
 void pop3_greet()
 {
-  char *s;
-  s = unique;
-  s += fmt_uint(s,getpid());
-  *s++ = '.';
-  s += fmt_ulong(s,(unsigned long) now());
-  *s++ = '@';
-  *s++ = 0;
-  puts("+OK <");
-  puts(unique);
-  puts(hostname);
-  puts(">\r\n");
-  flush();
+  dounique();
+  doserv(); out("+OK "); out("<"); out(unique); out(hostname); out(">");
+  doeol(); flush();
 }
+
 void pop3_user(arg) char *arg;
 {
   if (!*arg) { err_syntax(); return; }
-  okay();
   seenuser = 1;
-  if (!stralloc_copys(&username,arg)) die_nomem(); 
-  if (!stralloc_0(&username)) die_nomem(); 
+  if (!stralloc_copys(&username,arg)) die_nomem();
+  if (!stralloc_0(&username)) die_nomem();
+  ok(0);
 }
+
 void pop3_pass(arg) char *arg;
 {
   if (!seenuser) { err_wantuser(); return; }
   if (!*arg) { err_syntax(); return; }
+  if (!env_put2("AUTH", "POP3")) die_nomem();
   doanddie(username.s,username.len,arg);
 }
+
 void pop3_apop(arg) char *arg;
 {
   char *space;
   space = arg + str_chr(arg,' ');
   if (!*space) { err_syntax(); return; }
   *space++ = 0;
+  if (!env_put2("AUTH", "APOP")) die_nomem();
   doanddie(arg,space - arg,space);
 }
 
-struct commands pop3commands[] = {
+void dosasl() {
+  int i=0,space=0;
+  while (i<SASL_MAX) {
+    if ((*ctl_auth_current & 1<<i) == 1<<i) {
+      if (space) out(" ");
+      out(sasl[i]);flush();
+      space=1;
+    }
+    i++;
+  }
+}
+
+/*
+ * rfc2449: TOP USER SASL RESP-CODES LOGIN-DELAY
+ *          PIPELINING EXPIRE UIDL IMPLEMENTATION
+ * rfc2595: STLS
+ * rfc3206: AUTH-RESP-CODE
+ */
+void pop3_capa()
+{
+  out_err("+OK list of capabilities follows");
+  if (*ctl_auth_current) {
+    doserv(); out("SASL "); dosasl(); doeol();
+    out_err("AUTH-RESP-CODE");
+  }
+  out_err("TOP");
+  out_err("USER");
+  out_err("UIDL");
+  if (ctl_logindelay) out_err(logindelay); /* xxx: timeout = variable */
+  if (ctl_expire) out_err(expire);
+  if (tls_available && !tls_started) out_err("STLS");
+  out_err("PIPELINING");
+  out_err("RESP-CODES");
+  out_err("IMPLEMENTATION qmail patched " VERSION);
+  out_err(".");
+}
+
+void pop3_stls(arg) char *arg;
+{
+  if (!tls_available || tls_started)
+    return out_err("-ERR STLS not available");
+  out_err("+OK starting TLS negotiation");
+
+  if (!ucspitls())
+    die_tls();
+
+  /* issue new possibilities */
+  *ctl_auth_current = &ctl_auth_secure;
+
+  tls_started = 1;
+  /* reset state */
+  seenuser = 0;
+}
+
+void pop3_help()
+{
+  out_err("+OK list of valid commands follows");
+  out_err("user");
+  out_err("pass");
+  out_err("apop");
+  out_err("capa");
+  out_err("quit");
+  out_err("auth");
+  out_err("noop");
+  out_err("help");
+  out_err(".");
+}
+
+void pop3_auth(char *arg)
+{
+  char *cmd=arg;
+  int i;
+
+  if (!stralloc_copys(&user,"")) die_nomem();
+  if (!stralloc_copys(&pass,"")) die_nomem();
+  if (!stralloc_copys(&resp,"")) die_nomem();
+  if (str_len(arg) == 0 && *ctl_auth_current) {
+    if (!*ctl_auth_current) { err_unimpl(); return; }
+    out_err("+OK list of SASL extensions follows");
+    for (i=0; i<SASL_MAX; i+=1)
+      if ((*ctl_auth_current & 1<<i) == 1<<i)
+        out_err(sasl[i]);
+    out_err(".");
+    return;
+  }
+
+  i = str_chr(cmd,' ');
+  arg = cmd + i;
+  while (*arg == ' ') ++arg;
+  cmd[i] = 0;
+
+  for (i = 0; authcmds[i].text; ++i)
+    if (case_equals(authcmds[i].text,cmd)) break;
+
+  if ((*ctl_auth_current & 1<<i) != 1<<i) { err_noauth(); return; }
+
+  auth_for=MODE_POPUP;
+  switch (authcmds[i].fun(arg)) {
+    case ERR_AUTH_FAILED: err_authfail(); break;
+    case ERR_AUTH_INPUT:  err_authin();   break;
+    case ERR_AUTH_ABORT:  err_authabrt(); break;
+  }
+  flush();
+  _exit(0);
+}
+
+struct commands pop3commands[] =
+{
   { "user", pop3_user, 0 }
 , { "pass", pop3_pass, 0 }
 , { "apop", pop3_apop, 0 }
+, { "capa", pop3_capa, 0 }
 , { "quit", pop3_quit, 0 }
-, { "noop", okay, 0 }
-, { 0, err_authoriz, 0 }
+, { "auth", pop3_auth, 0 }
+, { "noop", pop3_okay, 0 }
+, { "help", pop3_help, 0 }
+, { "stls", pop3_stls, 0 }
+, { "stat", err_wantauth, 0 }
+, { "list", err_wantauth, 0 }
+, { "uidl", err_wantauth, 0 }
+, { "dele", err_wantauth, 0 }
+, { "rset", err_wantauth, 0 }
+, { "last", err_wantauth, 0 }
+, { "retr", err_wantauth, 0 }
+, { "top",  err_wantauth, 0 }
+, { 0,      err_unimpl, 0 }
 } ;
 
-void main(argc,argv)
-int argc;
-char **argv;
+void setup(void) {
+  char *x;
+
+  if (control_init() == -1) die_control();
+
+  /* logging */
+  if (control_readint(&ctl_log_in,"control/log/pop3_in") == -1)
+    die_control();
+  if (control_readint(&ctl_log_out,"control/log/pop3_out") == -1)
+    die_control();
+  if (control_readint(&ctl_log_fd,"control/log/pop3_fd") == -1)
+    die_control();
+
+  if (ctl_log_in  < 0) ctl_log_in=0;
+  if (ctl_log_out < 0) ctl_log_out=0;
+  if (ctl_log_fd  < 0) ctl_log_fd=0;
+  sserr.fd = ctl_log_fd;
+
+  /* login delay */
+  ctl_logindelay=0;
+  if (env_get("NO_LOGINDELAY")) {
+    ctl_logindelay=0;
+  } else {
+    x = env_get("LOGINDELAY");
+    if (x) {
+      if (scan_ulong(x,&ctl_logindelay) == 0) die_control();
+    } else {
+      if (control_readint(&ctl_logindelay,"control/logindelay") == -1)
+        die_control();
+    }
+  }
+  x=logindelay;
+  x+=fmt_str(x,"LOGIN DELAY ");
+  x+=fmt_uint(x,ctl_logindelay);
+  x=0;
+
+  ctl_auth_delay=0;
+  if (env_get("NO_AUTHDELAY")) {
+    ctl_auth_delay=0;
+  } else {
+    x = env_get("AUTHDELAY");
+    if (x) {
+      if (scan_ulong(x,&ctl_auth_delay) == 0) die_control();
+    } else {
+      if (control_readint(&ctl_auth_delay,"control/auth/delay") == -1)
+        die_control();
+    }
+  }
+
+  ctl_expire=0;
+  if (env_get("NO_EXPIRE")) {
+    ctl_expire=0;
+  } else {
+    x = env_get("EXPIRE");
+    if (x) {
+      if (scan_ulong(x,&ctl_expire) == 0) die_control();
+    } else {
+      if (control_readint(&ctl_expire,"control/expire") == -1) die_control();
+    }
+  }
+  x=expire;
+  x+=fmt_str(x,"EXPIRE ");
+  if (ctl_expire <= 0) {
+    x+=fmt_str(x," NEVER");
+  } else {
+    x+=fmt_uint(x,ctl_expire);
+  }
+  x=0;
+
+  if (control_readint(&ctl_auth_delay,    "control/auth/delay") == -1) die_control();
+  if (control_readint(&ctl_auth_secure,   "control/auth/spop3") == -1) die_control();
+  if (control_readint(&ctl_auth_insecure, "control/auth/pop3")  == -1) die_control();
+
+  /* buffer limit for commands */
+  if (control_readint(&ctl_maxcmdlen, "control/maxcmdlen") == -1) die_control();
+  if (ctl_maxcmdlen < 0) ctl_maxcmdlen=0;
+
+  return;
+}
+
+int main(int argc, char **argv)
 {
+  hostname = argv[1];
+  childargs = argv + 2;
+  sserr.fd=0;
+
   sig_alarmcatch(die);
   sig_pipeignore();
- 
-  hostname = argv[1];
+
+  if (chdir(auto_qmail) == -1) die_control();
+  setup();
+
   if (!hostname) die_usage();
-  childargs = argv + 2;
   if (!*childargs) die_usage();
- 
+  tls_available = !!env_get("UCSPITLS");
   pop3_greet();
-  commands(&ssin,pop3commands);
+  commands(&ssin,&sserr,pop3commands);
+
   die();
+  return 0; /* gcc happyness */
 }
diff -urN qmail-1.03-vanilla/qmail-pw2u.c qmail-1.03-md24/qmail-pw2u.c
--- qmail-1.03-vanilla/qmail-pw2u.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/qmail-pw2u.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,5 +1,6 @@
 #include <sys/types.h>
 #include <sys/stat.h>
+#include <unistd.h>
 #include "substdio.h"
 #include "readwrite.h"
 #include "subfd.h"
@@ -11,6 +12,7 @@
 #include "str.h"
 #include "scan.h"
 #include "open.h"
+#include "byte.h"
 #include "error.h"
 #include "getln.h"
 #include "auto_break.h"
@@ -228,7 +230,7 @@
 substdio ss;
 char ssbuf[SUBSTDIO_INSIZE];
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char **argv;
 {
diff -urN qmail-1.03-vanilla/qmail-qmqpc.c qmail-1.03-md24/qmail-qmqpc.c
--- qmail-1.03-vanilla/qmail-qmqpc.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/qmail-qmqpc.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,4 +1,5 @@
 #include <sys/types.h>
+#include <unistd.h>
 #include <sys/socket.h>
 #include <netinet/in.h>
 #include <arpa/inet.h>
@@ -102,14 +103,16 @@
 char *server;
 {
   struct ip_address ip;
+  struct ip_address outip;
   char ch;
 
+  outip.d[0]=outip.d[1]=outip.d[2]=outip.d[3]=(unsigned long)0;
   if (!ip_scan(server,&ip)) return;
 
   qmqpfd = socket(AF_INET,SOCK_STREAM,0);
   if (qmqpfd == -1) die_socket();
 
-  if (timeoutconn(qmqpfd,&ip,PORT_QMQP,10) != 0) {
+  if (timeoutconn(qmqpfd,&ip,&outip,PORT_QMQP,10) != 0) {
     lasterror = 73;
     if (errno == error_timeout) lasterror = 72;
     close(qmqpfd);
@@ -135,10 +138,9 @@
 
 stralloc servers = {0};
 
-main()
+int main(int argc, char **argv)
 {
-  int i;
-  int j;
+  int i,j;
 
   sig_pipeignore();
 
diff -urN qmail-1.03-vanilla/qmail-qmqpd.c qmail-1.03-md24/qmail-qmqpd.c
--- qmail-1.03-vanilla/qmail-qmqpd.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/qmail-qmqpd.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,3 +1,5 @@
+#include <sys/types.h>
+#include <unistd.h>
 #include "auto_qmail.h"
 #include "qmail.h"
 #include "received.h"
@@ -8,6 +10,9 @@
 #include "now.h"
 #include "fmt.h"
 #include "env.h"
+#include "str.h"
+#include "byte.h"
+#include "scan.h"
 
 void resources() { _exit(111); }
 
@@ -48,7 +53,7 @@
   for (;;) {
     getbyte(&ch);
     if (ch == ':') return len;
-    if (len > 200000000) resources();
+    if (len > 200000000 || ch < '0' || ch > '9') resources();
     len = 10 * len + (ch - '0');
   }
 }
@@ -105,7 +110,7 @@
 
 int flagok = 1;
 
-main()
+int main()
 {
   char *result;
   unsigned long qp;
@@ -163,7 +168,7 @@
   }
 
   if (!flagok)
-    result = "Dsorry, I can't accept addresses like that (#5.1.3)";
+    result = "D5.1.3 sorry, I can't accept addresses like that";
 
   substdio_put(&ssout,strnum,fmt_ulong(strnum,(unsigned long) str_len(result)));
   substdio_puts(&ssout,":");
diff -urN qmail-1.03-vanilla/qmail-qmtpd.c qmail-1.03-md24/qmail-qmtpd.c
--- qmail-1.03-vanilla/qmail-qmtpd.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/qmail-qmtpd.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,7 +1,10 @@
+#include <sys/types.h>
+#include <unistd.h>
 #include "stralloc.h"
 #include "substdio.h"
 #include "qmail.h"
 #include "now.h"
+#include "scan.h"
 #include "str.h"
 #include "fmt.h"
 #include "env.h"
@@ -14,6 +17,13 @@
 
 void badproto() { _exit(100); }
 void resources() { _exit(111); }
+void die_nomem() { resources(); }
+void die_control() { resources(); }
+void die_cdb() { resources(); }
+void die_sys() { resources(); }
+
+extern void realrcptto_init();
+extern int realrcptto();
 
 int safewrite(fd,buf,len) int fd; char *buf; int len;
 {
@@ -74,36 +84,38 @@
 char *relayclient;
 int relayclientlen;
 
-main()
+int main()
 {
   char ch;
   int i;
   unsigned long biglen;
   unsigned long len;
-  int flagdos;
+  int flagdos=0;
   int flagsenderok;
   int flagbother;
   unsigned long qp;
   char *result;
   char *x;
   unsigned long u;
- 
+
   sig_pipeignore();
   sig_alarmcatch(resources);
   alarm(3600);
- 
+
   if (chdir(auto_qmail) == -1) resources();
- 
+
   if (control_init() == -1) resources();
   if (rcpthosts_init() == -1) resources();
   relayclient = env_get("RELAYCLIENT");
   relayclientlen = relayclient ? str_len(relayclient) : 0;
- 
+
+  realrcptto_init();
+
   if (control_readint(&databytes,"control/databytes") == -1) resources();
   x = env_get("DATABYTES");
   if (x) { scan_ulong(x,&u); databytes = u; }
   if (!(databytes + 1)) --databytes;
- 
+
   remotehost = env_get("TCPREMOTEHOST");
   if (!remotehost) remotehost = "unknown";
   remoteinfo = env_get("TCPREMOTEINFO");
@@ -112,28 +124,28 @@
   local = env_get("TCPLOCALHOST");
   if (!local) local = env_get("TCPLOCALIP");
   if (!local) local = "unknown";
- 
+
   for (;;) {
     if (!stralloc_copys(&failure,"")) resources();
     flagsenderok = 1;
- 
+
     len = getlen();
     if (len == 0) badproto();
- 
+
     if (databytes) bytestooverflow = databytes + 1;
     if (qmail_open(&qq) == -1) resources();
     qp = qmail_qp(&qq);
- 
+
     substdio_get(&ssin,&ch,1);
     --len;
     if (ch == 10) flagdos = 0;
     else if (ch == 13) flagdos = 1;
     else badproto();
- 
+
     received(&qq,"QMTP",local,remoteip,remotehost,remoteinfo,(char *) 0);
- 
+
     /* XXX: check for loops? only if len is big? */
- 
+
     if (flagdos)
       while (len > 0) {
         substdio_get(&ssin,&ch,1);
@@ -161,9 +173,9 @@
       }
     }
     getcomma();
- 
+
     len = getlen();
- 
+
     if (len >= 1000) {
       buf[0] = 0;
       flagsenderok = 0;
@@ -178,15 +190,15 @@
       buf[len] = 0;
     }
     getcomma();
- 
+
     flagbother = 0;
     qmail_from(&qq,buf);
     if (!flagsenderok) qmail_fail(&qq);
- 
+
     biglen = getlen();
     while (biglen > 0) {
       if (!stralloc_append(&failure,"")) resources();
- 
+
       len = 0;
       for (;;) {
         if (!biglen) badproto();
@@ -208,15 +220,20 @@
           if (!buf[i]) failure.s[failure.len - 1] = 'N';
         }
         buf[len] = 0;
- 
-        if (relayclient)
+
+        if (relayclient) {
           str_copy(buf + len,relayclient);
-        else
+        } else {
           switch(rcpthosts(buf,len)) {
             case -1: resources();
             case 0: failure.s[failure.len - 1] = 'D';
           }
- 
+	}
+
+        if (!failure.s[failure.len - 1])
+          if (!realrcptto(buf))
+            failure.s[failure.len - 1] = 'D';
+
         if (!failure.s[failure.len - 1]) {
           qmail_to(&qq,buf);
           flagbother = 1;
@@ -226,12 +243,12 @@
       biglen -= (len + 1);
     }
     getcomma();
- 
+
     if (!flagbother) qmail_fail(&qq);
     result = qmail_close(&qq);
-    if (!flagsenderok) result = "Dunacceptable sender (#5.1.7)";
-    if (databytes) if (!bytestooverflow) result = "Dsorry, that message size exceeds my databytes limit (#5.3.4)";
- 
+    if (!flagsenderok) result = "D5.1.7 unacceptable sender";
+    if (databytes) if (!bytestooverflow) result = "D5.3.4 sorry, that message size exceeds my databytes limit";
+
     if (*result)
       len = str_len(result);
     else {
@@ -244,25 +261,26 @@
       buf2[len] = 0;
       result = buf2;
     }
-      
+
     len = fmt_ulong(buf,len);
     buf[len++] = ':';
     len += fmt_str(buf + len,result);
     buf[len++] = ',';
- 
+
     for (i = 0;i < failure.len;++i)
       switch(failure.s[i]) {
         case 0:
           substdio_put(&ssout,buf,len);
           break;
         case 'D':
-          substdio_puts(&ssout,"66:Dsorry, that domain isn't in my list of allowed rcpthosts (#5.7.1),");
+          substdio_puts(&ssout,"66:D5.7.1 sorry, that domain isn't in my list of allowed rcpthosts,");
           break;
         default:
-          substdio_puts(&ssout,"46:Dsorry, I can't handle that recipient (#5.1.3),");
+          substdio_puts(&ssout,"46:D5.1.3 sorry, I can't handle that recipient,");
           break;
       }
- 
+
     /* ssout will be flushed when we read from the network again */
   }
+  return 0; /* gcc happyness */
 }
diff -urN qmail-1.03-vanilla/qmail-qread.c qmail-1.03-md24/qmail-qread.c
--- qmail-1.03-vanilla/qmail-qread.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/qmail-qread.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,5 +1,6 @@
 #include <sys/types.h>
 #include <sys/stat.h>
+#include <unistd.h>
 #include "stralloc.h"
 #include "substdio.h"
 #include "subfd.h"
@@ -105,7 +106,7 @@
 
 stralloc line = {0};
 
-void main()
+int main()
 {
  int channel;
  int match;
@@ -118,7 +119,7 @@
  if (chdir("queue") == -1) die_chdir();
  readsubdir_init(&rs,"info",die_opendir);
 
- while (x = readsubdir_next(&rs,&id))
+ while ((x = readsubdir_next(&rs,&id)))
    if (x > 0)
     {
      fmtqfn(fnmess,"mess/",id,1);
@@ -172,4 +173,5 @@
     }
 
  die(0);
+ return 0;
 }
diff -urN qmail-1.03-vanilla/qmail-qstat.sh qmail-1.03-md24/qmail-qstat.sh
--- qmail-1.03-vanilla/qmail-qstat.sh	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/qmail-qstat.sh	2007-07-19 20:56:22.000000000 +0200
@@ -1,7 +1,7 @@
 cd QMAIL
 messdirs=`echo queue/mess/* | wc -w`
 messfiles=`find queue/mess/* -print | wc -w`
-tododirs=`echo queue/todo | wc -w`
-todofiles=`find queue/todo -print | wc -w`
+tododirs=`echo queue/todo/* | wc -w`
+todofiles=`find queue/todo/* -print | wc -w`
 echo messages in queue: `expr $messfiles - $messdirs`
 echo messages in queue but not yet preprocessed: `expr $todofiles - $tododirs`
diff -urN qmail-1.03-vanilla/qmail-queue.c qmail-1.03-md24/qmail-queue.c
--- qmail-1.03-vanilla/qmail-queue.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/qmail-queue.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,5 +1,7 @@
 #include <sys/types.h>
 #include <sys/stat.h>
+#include <unistd.h>
+#include <fcntl.h>
 #include "readwrite.h"
 #include "sig.h"
 #include "exit.h"
@@ -16,6 +18,10 @@
 #include "auto_uids.h"
 #include "date822fmt.h"
 #include "fmtqfn.h"
+#include "byte.h"
+#include "constmap.h"
+#include "control.h"
+#include "stralloc.h"
 
 #define DEATH 86400 /* 24 hours; _must_ be below q-s's OSSIFIED (36 hours) */
 #define ADDR 1003
@@ -40,6 +46,11 @@
 int flagmademess = 0;
 int flagmadeintd = 0;
 
+int bbon = 0;
+stralloc bbs = {0}; /* control/bigbrother */
+stralloc bba = {0}; /* from/to addr */
+struct constmap mapbb;
+
 void cleanup()
 {
  if (flagmadeintd)
@@ -57,6 +68,7 @@
 void die(e) int e; { _exit(e); }
 void die_write() { cleanup(); die(53); }
 void die_read() { cleanup(); die(54); }
+void die_bb() { cleanup(); die(51); }
 void sigalrm() { /* thou shalt not clean up here */ die(52); }
 void sigbug() { die(81); }
 
@@ -151,14 +163,31 @@
 
 char tmp[FMT_ULONG];
 
-void main()
+int main()
 {
- unsigned int len;
- char ch;
+ unsigned int len, xlen, n;
+ const char *b;
+ char ch, *x;
+ int fd;
 
  sig_blocknone();
  umask(033);
  if (chdir(auto_qmail) == -1) die(61);
+
+ if (control_init() == -1) die(55);
+ switch (control_readfile(&bbs,"control/bigbrother",0)) {
+   case -1:
+     die(55);
+   case 0:
+     bbon = 0;
+     if (!constmap_init(&mapbb,"",0,1)) die(51);
+     break;
+   case 1:
+     bbon = 1;
+     if (!constmap_init(&mapbb,bbs.s,bbs.len,1)) die(51);
+     break;
+ }
+
  if (chdir("queue") == -1) die(62);
 
  mypid = getpid();
@@ -180,10 +209,11 @@
 
  messnum = pidst.st_ino;
  messfn = fnnum("mess/",1);
- todofn = fnnum("todo/",0);
- intdfn = fnnum("intd/",0);
+ todofn = fnnum("todo/",1);
+ intdfn = fnnum("intd/",1);
 
  if (link(pidfn,messfn) == -1) die(64);
+ if ((fd = open(messfn, O_RDONLY)) < 0 || fsync(fd) < 0 || close(fd) < 0) die(64);
  if (unlink(pidfn) == -1) die(63);
  flagmademess = 1;
 
@@ -223,6 +253,7 @@
   {
    if (substdio_get(&ssin,&ch,1) < 1) die_read();
    if (substdio_put(&ssout,&ch,1) == -1) die_write();
+   if (bbon) if (!stralloc_catb(&bba, &ch, 1)) die_bb();
    if (!ch) break;
   }
  if (len >= ADDR) die(11);
@@ -235,20 +266,38 @@
    if (!ch) break;
    if (ch != 'T') die(91);
    if (substdio_bput(&ssout,&ch,1) == -1) die_write();
-   for (len = 0;len < ADDR;++len)
-    {
+   for (len = 0;len < ADDR;++len) {
      if (substdio_get(&ssin,&ch,1) < 1) die_read();
      if (substdio_bput(&ssout,&ch,1) == -1) die_write();
+     if (bbon) if (!stralloc_catb(&bba, &ch, 1)) die_bb();
      if (!ch) break;
-    }
+   }
    if (len >= ADDR) die(11);
   }
 
+ if (bbon) {
+   x = bba.s;
+   xlen = bba.len;
+   do {
+     n = byte_chr(x,xlen,0);
+     if ((b = constmap(&mapbb, x, n))) {
+       if (*b) {
+         if (substdio_bput(&ssout,"T", 1) == -1) die_write();
+         if (substdio_bputs(&ssout,b) == -1) die_write();
+         if (substdio_bput(&ssout,"",1) == -1) die_write();
+       }
+     }
+     if (n++ >= xlen) break;
+     x += n; xlen -= n;
+   } while (xlen > 0);
+ }
+
  if (substdio_flush(&ssout) == -1) die_write();
  if (fsync(intdfd) == -1) die_write();
 
  if (link(intdfn,todofn) == -1) die(66);
+ if ((fd = open(todofn, O_RDONLY)) < 0 || fsync(fd) < 0 || close(fd) < 0) die(66);
 
  triggerpull();
- die(0);
+ return 0;
 }
